#pragma once
#define _USE_MATH_DEFINES
#include "math.h"
#include <iostream>
#include <fstream>
using namespace std;

struct Point3D
{
	double X, Y, Z;
};

Point3D operator+(Point3D a, Point3D b)
{
	Point3D c;
	c.X=a.X+b.X;
	c.Y=a.Y+b.Y;
	c.Z=a.Z+b.Z;
	return c;
};


namespace StupidBUK {

	using namespace System;
	using namespace System::ComponentModel;
	using namespace System::Collections;
	using namespace System::Windows::Forms;
	using namespace System::Data;
	using namespace System::Drawing;

	/// <summary>
	///   Form1
	///
	/// !        
	///              ("Resource File Name")     ,
	///                .resx,     .   ,
	///                
	///          ,   .
	/// </summary>
	public ref class Form1 : public System::Windows::Forms::Form
	{
	public:
		Form1(void)
		{
			InitializeComponent();
			//
			//TODO:   
			//
		}

	protected:
		/// <summary>
		///    .
		/// </summary>
		~Form1()
		{
			if (components)
			{
				delete components;
			}
		}
	private: System::Windows::Forms::PictureBox^  pictureBox1;
	private: System::Windows::Forms::Button^  button1;
	private: System::Windows::Forms::ProgressBar^  progressBar1;
	protected: 

	private:
		/// <summary>
		///   .
		/// </summary>
		System::ComponentModel::Container ^components;

#pragma region Windows Form Designer generated code
		/// <summary>
		///      -  
		///       .
		/// </summary>
		void InitializeComponent(void)
		{
			System::ComponentModel::ComponentResourceManager^  resources = (gcnew System::ComponentModel::ComponentResourceManager(Form1::typeid));
			this->pictureBox1 = (gcnew System::Windows::Forms::PictureBox());
			this->button1 = (gcnew System::Windows::Forms::Button());
			this->progressBar1 = (gcnew System::Windows::Forms::ProgressBar());
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^  >(this->pictureBox1))->BeginInit();
			this->SuspendLayout();
			// 
			// pictureBox1
			// 
			this->pictureBox1->Image = (cli::safe_cast<System::Drawing::Image^  >(resources->GetObject(L"pictureBox1.Image")));
			this->pictureBox1->InitialImage = (cli::safe_cast<System::Drawing::Image^  >(resources->GetObject(L"pictureBox1.InitialImage")));
			this->pictureBox1->Location = System::Drawing::Point(0, 3);
			this->pictureBox1->Margin = System::Windows::Forms::Padding(0);
			this->pictureBox1->Name = L"pictureBox1";
			this->pictureBox1->Size = System::Drawing::Size(908, 742);
			this->pictureBox1->TabIndex = 0;
			this->pictureBox1->TabStop = false;
			this->pictureBox1->WaitOnLoad = true;
			// 
			// button1
			// 
			this->button1->Location = System::Drawing::Point(469, 748);
			this->button1->Name = L"button1";
			this->button1->Size = System::Drawing::Size(182, 23);
			this->button1->TabIndex = 1;
			this->button1->Text = L"button1";
			this->button1->UseVisualStyleBackColor = true;
			this->button1->Click += gcnew System::EventHandler(this, &Form1::button1_Click);
			// 
			// progressBar1
			// 
			this->progressBar1->Location = System::Drawing::Point(251, 753);
			this->progressBar1->Maximum = 907;
			this->progressBar1->Name = L"progressBar1";
			this->progressBar1->Size = System::Drawing::Size(197, 8);
			this->progressBar1->Step = 1;
			this->progressBar1->Style = System::Windows::Forms::ProgressBarStyle::Continuous;
			this->progressBar1->TabIndex = 2;
			// 
			// Form1
			// 
			this->AutoScaleDimensions = System::Drawing::SizeF(6, 13);
			this->AutoScaleMode = System::Windows::Forms::AutoScaleMode::Font;
			this->ClientSize = System::Drawing::Size(909, 773);
			this->Controls->Add(this->progressBar1);
			this->Controls->Add(this->button1);
			this->Controls->Add(this->pictureBox1);
			this->MaximumSize = System::Drawing::Size(917, 800);
			this->MinimumSize = System::Drawing::Size(917, 800);
			this->Name = L"Form1";
			this->Text = L"Form1";
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^  >(this->pictureBox1))->EndInit();
			this->ResumeLayout(false);

		}
#pragma endregion

	int JointColours(Color c1, Color c2)
	{
		unsigned int ic1=c1.ToArgb();
		unsigned int ic2=c2.ToArgb();
		unsigned int ic3=0;
		
		unsigned int base=1;
		for(int n=1; n<=4; n++)
		{
			unsigned int p1=ic1-256*(ic1/256);
			unsigned int p2=ic2-256*(ic2/256);
			unsigned int p3=(p1+p2)/2;
			
			ic3=ic3+p3*base;
			ic1=ic1/256;
			ic2=ic2/256;

			base=base*256;
		}

		return ic3;
	}

	double epsilon(double l)
	{
		double lp[5]={13, 15, 19, 22, 26};
		double ep[5]={30, 22, 5, 0, -5};
		
		int i;
		for(i=0; i<=2; i++) if(lp[i+1]>l) break;
		
		return ep[i] + (l-lp[i])*(ep[i+1]-ep[i])/(lp[i+1]-lp[i]);

	};


	double velocity(double epsilon)
	{
		double vp[2]={730, 600};
		double ep[2]={22, 5};
		return vp[0] + (epsilon-ep[0])*(vp[1]-vp[0])/(ep[1]-ep[0]);
	};


	double cone_angle(double velocity)
	{
		double cone_zero_velocity=112;
		double highest_frag_velocity=2520;

		double vn=highest_frag_velocity*sin(cone_zero_velocity*M_PI/180);

		double vt=highest_frag_velocity*cos(cone_zero_velocity*M_PI/180);
		double vt_new=vt+velocity;

		return 90-atan(vt_new/vn)*180/M_PI;
	};

	private: System::Void button1_Click(System::Object^  sender, System::EventArgs^  e) {
				 pictureBox1->Load("dutch.bmp");	
				 Bitmap^ Map = gcnew Bitmap(pictureBox1->Image);
				 
				 int X_FDR=237;
				 int Y_FDR=114;

				 double x_scale=10./(272-102);
				 double y_scale=x_scale;

				 /*
				 for(int X_Launch=0; X_Launch<=907; X_Launch++)
				 {
					for(int Y_Launch=Y_FDR+1; Y_Launch<=739; Y_Launch++)
					{
						double dx= x_scale*(X_FDR-X_Launch);
						double dy=-y_scale*(Y_FDR-Y_Launch);
						
						double l=sqrt(dx*dx+dy*dy);

						double az=asin(dx/l)*180/M_PI;
						double beta_nominal=(az+(180-115));

						if(l>35||l<20) continue;
						if(beta_nominal>90||beta_nominal<0) continue;
						
						Color additionalColour;
						additionalColour=additionalColour.White;
						if(beta_nominal>30) additionalColour=additionalColour.Yellow; 
						Color pixelColour=Map->GetPixel(X_Launch, Y_Launch);
						pixelColour=pixelColour.FromArgb(JointColours(pixelColour, additionalColour));
						Map->SetPixel(X_Launch, Y_Launch, pixelColour);  
					}
				 }
				 pictureBox1->Image=Map;
				 Map->Save("MH17_map_test.bmp");
				 */
				 
		 
				 int Map_Step=1;	
				 for(int X_Launch=0; X_Launch<=907; X_Launch=X_Launch+Map_Step)
				 {
					progressBar1->Increment(Map_Step);
					for(int Y_Launch=Y_FDR+1; Y_Launch<=739; Y_Launch=Y_Launch+Map_Step)
					{
						double dx= x_scale*(X_FDR-X_Launch);
						double dy=-y_scale*(Y_FDR-Y_Launch);
						
						double l=sqrt(dx*dx+dy*dy);

						double az=asin(dx/l)*180/M_PI;
						double beta_nominal=(az+(180-115));

						if(l>35||l<10) continue;
						if(beta_nominal>120||beta_nominal<-10) continue;
						
						double epsilon_blast=epsilon(l);
						double v_blast=velocity(epsilon_blast);
						double cone_blast=cone_angle(v_blast);
						
						double beta_drift=-4;
						double beta_q=2;
						double beta_blast=beta_nominal-beta_drift-beta_q;

						Point3D blast_point;
						blast_point.X=-0.25;
						blast_point.Y=-3.0;
						blast_point.Z=3.7;
						
						Point3D match_point;
						match_point.X=1.59;
						match_point.Y=0;
						match_point.Z=1.56;

						double rho;
						double phi;
						double miss_min=1e10;
						
						for(rho=0.1; rho<=8.0; rho=rho+0.1)
						{
							for(phi=-90; phi<=90; phi=phi+1)
							{
								double r=rho*sin(cone_blast*M_PI/180);
								double h=-rho*cos(cone_blast*M_PI/180);

								double MS=r*cos(phi*M_PI/180);
								double CS=r*sin(phi*M_PI/180);
								double CO=h;
								double SO=sqrt(CO*CO+CS*CS);
						
								double omega=-atan(CS/CO)*180/M_PI;
								double theta=omega+epsilon_blast;
								
								Point3D Vector_MS;
								Vector_MS.Z=0;
								Vector_MS.X=-MS*sin(beta_blast*M_PI/180);
								Vector_MS.Y=-MS*cos(beta_blast*M_PI/180);
								
								Point3D Vector_SO;
								Vector_SO.Z=SO*sin(theta*M_PI/180);
								Vector_SO.X=SO*cos(theta*M_PI/180)*cos(beta_blast*M_PI/180);
								Vector_SO.Y=-SO*cos(theta*M_PI/180)*sin(beta_blast*M_PI/180);

								double t=rho/2520; 
								double PM=t*252;

								Point3D Vector_PM;
								Vector_PM.Z=0;
								Vector_PM.X=-PM*cos(beta_drift*M_PI/180);
								Vector_PM.Y=PM*sin(beta_drift*M_PI/180);

								Point3D warhead_point;
								warhead_point=match_point+Vector_PM+Vector_MS+Vector_SO;

								double miss=sqrt((warhead_point.X-blast_point.X)*(warhead_point.X-blast_point.X)
												+(warhead_point.Y-blast_point.Y)*(warhead_point.Y-blast_point.Y)
												+(warhead_point.Z-blast_point.Z)*(warhead_point.Z-blast_point.Z)
												);

								if(miss<miss_min) miss_min=miss;
							}
						}

				
						double r_blast= pow((3/(4*M_PI)), 1./3);

						Color additionalColour;
						if(miss_min<0.5*r_blast) additionalColour=additionalColour.Black;
						else if(miss_min<1*r_blast) additionalColour=additionalColour.Red;
						else if(miss_min<2*r_blast) additionalColour=additionalColour.Yellow;
						else if(miss_min<3*r_blast) additionalColour=additionalColour.Green;
						else additionalColour=additionalColour.White;

						Color pixelColour=Map->GetPixel(X_Launch, Y_Launch);
						pixelColour=pixelColour.FromArgb(JointColours(pixelColour, additionalColour));
						Map->SetPixel(X_Launch, Y_Launch, pixelColour);  
					}
				 }
				 pictureBox1->Image=Map;
				 Map->Save("MH17.bmp");
				 	

				 
				 ofstream f;
				 f.open("res.txt");
				 for(double l=10; l<=35; l=l+1)
				 {
					f<<l<<" "
					 <<epsilon(l)<<"  "
					 <<velocity(epsilon(l))<<"  "
					 <<cone_angle(velocity(epsilon(l)))
					 <<endl;
				 }
				 f<<endl;	
				 f.close();
 			 }
	};
}

